#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const long long mod=998244353;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

long long s[200001];
long long maxx;

long long mult(long long x,long long p)
{
    if(p==0)return 1;
    if(p==1)return x;
    long long h=mult(x,p/2);
    if(p%2==0)return h*h%mod;
    return (h*h%mod)*x%mod;
}

long long n,q,p[200001];
long long b[200001];
long long h[200001];
void read()
{
    cin>>n>>q;
    for(long long i=1; i<=n; i++)
    {
        cin>>p[i];
        s[i]=p[i];
    }

    for(long long i=1; i<=q; i++)
        cin>>b[i];
}

long long ans[2][2][2];
map<vector<long long>, long long> num;
long long w[8],nxt[8][3];

void solve()
{
    for(long long i=0;i<8;i++)
    {
        long long p1=0,p2=0,p3=0;
        if(i&1)
        {
            p1=1;
            for(long long j=1;j<=n;j++)
                h[j]=p[n-j+1];

            for(long long j=1;j<=n;j++)
                p[j]=h[j];
        }

        if(i&2)
        {
            p2=1;
            for(long long j=1;j<=n;j++)
                h[j]=n-p[j]+1;
            for(long long j=1;j<=n;j++)
                p[j]=h[j];
        }

        if(i&4)
        {
            p3=1;
            for(long long j=1;j<=n;j++)
                h[p[j]]=j;
            for(long long j=1;j<=n;j++)
                p[j]=h[j];
        }

        for(long long j=1;j<=n;j++)
        {
            ans[p1][p2][p3]+=mult(p[j],j);
            ans[p1][p2][p3]%=mod;
        }

        vector<long long> c;
        for(long long j=1;j<=n;j++)
        {
            c.push_back(p[j]);
        }
        num[c]=i;
        w[i]=ans[p1][p2][p3];

        //cout<<p1<<" "<<p2<<" "<<p3<<" "<<ans[p1][p2][p3]<<" ";
        //cout<<endl;

        for(long long j=1;j<=n;j++)
            p[j]=s[j];
    }

    for(long long i=0;i<8;i++)
    {
        long long p1=0,p2=0,p3=0;
        if(i&1)
        {
            p1=1;
            for(long long j=1;j<=n;j++)
                h[j]=p[n-j+1];

            for(long long j=1;j<=n;j++)
                p[j]=h[j];
        }

        if(i&2)
        {
            p2=1;
            for(long long j=1;j<=n;j++)
                h[j]=n-p[j]+1;
            for(long long j=1;j<=n;j++)
                p[j]=h[j];
        }

        if(i&4)
        {
            p3=1;
            for(long long j=1;j<=n;j++)
                h[p[j]]=j;
            for(long long j=1;j<=n;j++)
                p[j]=h[j];
        }

        if(1)
        {
            vector<long long> c;
            for(long long j=1;j<=n;j++)
                c.push_back(p[n-j+1]);
            nxt[i][1]=num[c];
        }

        if(2)
        {
            vector<long long> c;
            for(long long j=1;j<=n;j++)
                c.push_back(n-p[j]+1);
            nxt[i][2]=num[c];
        }

        if(3)
        {
            vector<long long> c(n);
            for(long long j=1;j<=n;j++)
                c[p[j]-1]=j;
            nxt[i][3]=num[c];
        }

        for(long long j=1;j<=n;j++)
            p[j]=s[j];
    }

    vector<long long> c;
    for(long long i=1;i<=n;i++)
        c.push_back(p[i]);

    long long ver=num[c];
    for(long long i=1;i<=q;i++)
    {
        ver=nxt[ver][b[i]];
        if(w[ver]==0)
        {
            for(int j=1;j<=1e9;j++);
        }
        cout<<w[ver]<<" ";

        //cout<<c1<<" "<<c2<<" "<<c3<<" "<<ans[c1][c2][c3]<<endl;
    }
    cout<<endl;
    //cout<<endl;
}

int main()
{
    speed();
    read();
    solve();
    return 0;
}
